/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 


//  xxxxxxxxxxxxxxx     wm7 variable declarations  xxxxxxxxxxxxxxxx

// Note: let and const are not used because of backward compatibility

// These variables below can be directly modified by the user on the options form: 

var lc = 1;       // minimum visible shapes

var hc = 4;     // maximum visible shapes

var wc = 2;    // number of item within each level between lc..hc

var is_shuffle=false;   // random shuffle items or not

var is_cor= true;     //  if (true) => One of the options offered will always be correct (equal to the target stimulus)

var uniq= false;  // if (uniq==false) => Shapes within drawings can be different  else => "Shapes within drawing will be unique (different) if possible 

var timer = 60;     // Task time in seconds if clock = 1000ms (default). 

var timer_enabled = true;   // if true => timer is enabled. if false timer is disabled 

var emoji = true;   // stimulus generator. if (emoji) => draw E-moji, else draw geometric shapes.  

/*  stype => stimulator type => difference between match (target) stimulus and options
  "0" = shape and color 
  "1" = only color
  "2" = only shape 
  "3" = only position  */
var stype = "2"; 
   
var ch = 4;       // choices count (1..10).
   
var size = 1;         // shape size   
var arr_size = [0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1];  // array const for size.  See wm7.html: <input type="number" id="size" min="1" max="10" step="1" value="10">

var tcolor= false;   // if (tcolor==false) => only basic different 10 colors are used ; else if (tcolor==true) all colors will be used 

var is_back = true;    // if (is_back==true) => user can go back to previous item (Undo) 

var is_forward= true;  // if (is_forward==true) => user can escape (skip) items. Next item button vill be visible. 

var demo = false;       // if (demo == true) => show correct solution

var is_shadow = false;     // if (true) => shadow screen answers (options) sections

var store = false;      // false => this web application will not store results within client web browser.; true => This web application will store the results inside client web browser. 

// Other wm7 variables and constants:

var clock = 1000;  // basic timer resolution in ms. Default = 1s (1000ms)

var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().

var counter = 0;      // timer counter. if (counter >= time) Timer will call theEnd()   

var item = 0;   // current item      

var cor = [];   // correct answer for each item

var ans = [];  //  user (client) answer for each item 

var r;      // shape radius (square base -width/height)  - x and y raster

var dirty = false;  // if  (dirty==true) => user changed any options in form 

var itemCnt;       // total item count  =>   itemCnt= wc*(hc-lc+1); 

var is_task = false;    // task in progress or not  (for timer)
      
var stim_b = [];        // canvas (viewport) choices (options) bounds => stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..ch

/*  stim = jagged array= for each item [item][option][shape] is separate array:
[ 0.index= show(1) or hide(0), 
  1.index = x screen coord, 
  2.index = y screen coord
  3.index = shape color
  4.index = shape type (circle, polygon, star,..) 
]
*/
var stim = [];  

// array values constants for Emoji drawings:
//var arr = [8986, 8987, 9200, 9748, 9749, 9875, 9917, 9924, 9925, 9940, 9962, 9970, 9973, 9981, 9986, 9989, 9992, 9993, 9995, 10062, 11088, 127746, 127749, 127796, 127797, 127800, 127802, 127803, 127805, 127806, 127807, 127809, 127812, 127813, 127815, 127827, 127925, 127931, 127984, 128018, 128024, 128054, 128105, 128107, 128115, 128116, 128118, 128123, 128124, 128152 ];                 
var arr = [8986, 8987, 9200, 9748, 9749, 9875, 9917, 9924, 9925, 9940, 
           9962, 9970, 9973, 9981, 9986, 9989, 9992, 9993, 9995, 10062,
           11088, 127746, 127749, 127796, 127797, 127800, 127802, 127803, 127805, 127806,
           127807, 127809, 127812, 127813, 127815, 127827, 127925, 127931, 127984, 128018, 
           128024, 128054, 128105, 128107, 128115, 128116, 128118, 128123, 128124, 128152 ];                     

var s_max= arr.length-1;     // maximum shape type [arr.lenght-1 or 40 or 21]. Don't change this without changing dependent functions (see source code) 


//  xxxxxxxxxxxxxxx     wm7 functions  xxxxxxxxxxxxxxxx


// create/start Timer, [center panels], and show start panel.. 
function init() 
{    
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }  
  timer_id= setInterval(function () {wm7Timer()},clock); 
  if (!supportedTransform())  {
    doCenter(document.getElementById("start"));
  }  
  showStart(); 
  if (isStorage() && storageAvailable('localStorage'))  
  {
    document.getElementById("store_group").disabled= false;
  }
  else 
  {
    document.getElementById("store_msg").textContent= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline).";
    document.getElementById("store_group").disabled= true;  
    document.getElementById("clr_store").disabled= true;     // IE11 bug  => childrens are not auto disabled
    document.getElementById("store").disabled= true;          // IE11 bug => childrens are not auto disabled
  }      
}


//  check for browser supported transform
function supportedTransform() 
{
  var prefixes = "transform WebkitTransform MozTransform OTransform msTransform".split(" ");
  var div = document.getElementById("wrapper");
  for(var i = 0; i < prefixes.length; i++) {
    if(div && div.style[prefixes[i]] !== undefined) {
      return prefixes[i];
    }
  }
  return false;
}


// center start panel
function doCenter(e)  
{      
  e.style= (window.innerWidth > 600 && window.innerHeight > 600 ) 
  ? "position:absolute;min-width:50%;min-height:50%;margin:auto;overflow:auto;"  
  : "position:absolute;min-width:75%;min-height:75%;margin:auto;overflow:auto;";  
}


// show start panel 
function showStart()  
{      
  document.getElementById("end").style.display= "none";
  document.getElementById("google-wrapper").style.display="none";  
  document.getElementById("start").style.display= "block";
}


// before using web storage, check browser support for localStorage and sessionStorage
function isStorage()  {
  if (typeof(Storage) !== "undefined") {
     return true;               // Code for localStorage/sessionStorage.     
  } 
  else {
    return false;           // code for no browser Web Storage support
  }  
}


// necessarily because of IE11 and Edge offline mode
function storageAvailable(type) {
  try  {
    return (window[type]) ? true: false;   
  }
  catch(e) {
    return false;
  }
}


// show forms with application options
// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   
{
  document.getElementById("hide_option").style.display ="block";
  document.getElementById("options").style.display= "block";
  document.getElementById("start").classList.remove("child");  // don't work in <= IE 9    
  document.getElementById("start_div").style.display="none";  // .disabled = true;   
  document.getElementById("show_option").style.display ="none";  
  document.getElementById("hide_option").style="text-align:center";  // bug? auto-remove style when element.style.display="none"
  document.getElementById("instructions").style.display ="none";     
  if ( document.getElementById("store_group").disabled === false && localStorage.getItem("wm7-v1.0")) 
  {
    var cnt= JSON.parse(localStorage.getItem("wm7-v1.0")).length;                                                        
    document.getElementById("store_cnt").textContent=  "You have a total of " + cnt  + " wm7 results stored in your web browser";
  }
  dirty= false;
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user Options/Settings
function hideOption()  
{
  setVarPar();   
  document.getElementById("options").style.display="none"; 
  document.getElementById("start").classList.add("child");   
  document.getElementById("show_option").style.display ="block";   
  document.getElementById("start_div").style.display="block";        //.removeAttribute("disabled");  
  document.getElementById("hide_option").style.display ="none";   
  document.getElementById("start_div").style="text-align:center";  // bug?  (firefox auto remove class "center" when set style.display.none;)
  document.getElementById("show_option").style="text-align:center";   // bug?
  document.getElementById("instructions").style.display ="block";
  document.getElementById("ins_back").style.display = (is_back) ? "block" : "none";
  document.getElementById("ins_forward").style.display = (is_forward) ? "block" : "none";
  document.getElementById("ins_timer").style.display = (document.getElementById("timer_enabled").checked) ? "block" : "none";   
  refMsg();  
}

       
// refresh variable research Options (update *_msg label) => give user short option HELP
function refOption(e)  
{   
  dirty=true;       
  var my_id = e.id, msg = document.getElementById(my_id + "_msg"), s = "Values within this range are allowed: ", s2= " with step= ";    
  
  // Items (6x)
  if ( my_id === "lc")  {
    if (e.validity.valid)  {           
      msg.removeAttribute("class");       
      msg.textContent= "";       //msg.textContent=  e.value; 
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");    // msg.className = 'error';
    } 
    refItem();
  }   
     
  else if ( my_id === "hc")  {
    if (e.validity.valid)  {     
      msg.removeAttribute("class");         
      msg.textContent= "";         //   msg.textContent=  e.value;
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step; 
      msg.setAttribute("class", "error");
    }  
    refItem();
  }      
  
  else if (my_id === "wc")  {    
    if (e.validity.valid)  {       
      msg.removeAttribute("class");        
      msg.textContent= "";        //msg.textContent=  e.value; 
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");    // msg.className = 'error';
    }         
    refItem();
  } 
  
  else if (my_id === "is_shuffle")  {                                                                                                                                            
    msg.textContent= (e.value === "0") ? "Items will be displayed from easier (Start level) to more difficult (Final level)" : "Items will be mixed randomly";
  }      
  
  else if (my_id === "is_cor")  {                                                                                                                                            
    if (e.value === "0") {
      msg.textContent= "There may not be an exact solution in some tasks";        //None of the drawings must always be accurate
      document.getElementById("is_forward").checked = true; 
      document.getElementById("is_forward").disabled = true; 
      document.getElementById("is_forward_msg").textContent= "Yes";      
    }
    else {                       
      msg.textContent= "One of the options offered will always be correct (equal to the target stimulus)";
      document.getElementById("is_forward").disabled = false;
    }   
  }    
  
  else if (my_id === "uniq")  {                                                                                                                                            
    msg.textContent= (e.value === "0") ? "Shapes can be repeated within the same option" : "Shapes within option will be different if possible";  
    document.getElementById("resol").disabled =  (e.value === "0")  ? false : true;    // greater value s_max for unique shapes must be used. This variable uniq takes precedence over the variable resol (s_max)
  }    
  
  // Temporal resolution (x2)      
    
  else if ( my_id === "timer")  {
    if (e.validity.valid) {
      msg.textContent= string_time(e.value); 
      msg.removeAttribute("class");
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");
    } 
  } 
  else if ( my_id === "timer_enabled")  
  {
    if (e.checked) {
      msg.textContent= "Yes";
      document.getElementById("timer").disabled = false;
    }
    else  {  
       msg.textContent= "Timer is disabled";
       document.getElementById("timer").disabled =true; 
     }       
  }
                          
  // Paradigm design (x11) 
  
  else if (my_id === "emoji")  
  {
    if (e.value === "1")  {  
      msg.innerHTML= "You should see elephant here: " + "&#128024";    
      document.getElementById("stype").value = 2;
      document.getElementById("stype").disabled = true;     
      document.getElementById("stype_msg").textContent= "Emoji will be displayed.";
      document.getElementById("resol").disabled = true; 
      document.getElementById("tcolor").disabled = false; 
  }             
    else  
    {            
      msg.textContent="Geometric shapes will be displayed.";       
      document.getElementById("stype").disabled = false;
      if (document.getElementById("uniq").value === "0")  document.getElementById("resol").disabled = false;  // only if shapes are not unique
    }
  }
  
  else if (my_id === "stype")  {
     if (e.value === "0")  {
       msg.textContent= "Different geometric shapes in different colors will be displayed (only for Shapes)"; 
       document.getElementById("tcolor").disabled = false;
       document.getElementById("uniq").disabled = false; 
       document.getElementById("resol").disabled = false;
     }
     else if (e.value === "1")  {
       msg.textContent=  "Circles of different colors will be displayed (only for Shapes)";
       document.getElementById("tcolor").disabled = false; 
       document.getElementById("uniq").disabled = true; 
       document.getElementById("resol").disabled = true;            
     }
      else if (e.value === "2")  {  
        msg.textContent= "For shapes: Different geometric shapes will always be displayed in black. For Emoji: Different Emoji will be displayed"; 
        if (document.getElementById("emoji").value != "1" ) document.getElementById("tcolor").disabled = true;
        document.getElementById("uniq").disabled = false;
        document.getElementById("resol").disabled = false;
      } 
      else if (e.value === "3")  {  
        msg.textContent="Black circles will be displayed and their spatial position on the screen will be varied (only for Shapes)";
        if (document.getElementById("emoji").value != "1" ) document.getElementById("tcolor").disabled = true;
        document.getElementById("uniq").disabled = true;  
        document.getElementById("resol").disabled = true;
      }        
  }    
 
  else if ( my_id === "ch")  {
    if (e.validity.valid)  {           
      msg.removeAttribute("class");       
      msg.textContent= "";       
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");  
    }  //document.getElementById("is_cor").disabled = (e.value === "1") ? true : false;      // for only one option stimulus is_cor must be false
    if (e.value === "1") {  // see setStim() => this function check if (ch>1)
      document.getElementById("is_cor").disabled = true;      // for only one option stimulus is_cor must be false
      document.getElementById("is_forward").disabled = true;
    }
    else  {
      document.getElementById("is_cor").disabled = false;      
      document.getElementById("is_forward").disabled = false;    
    }    
  }      
                    
  else if (my_id === "size")  {  
    if ( e.validity.valid ) {  //  Also significantly depends on the Final level. The higher it is, the size of shapes is smaller and vice versa.                   
      msg.textContent= "Higher number = larger drawing. Lower number = smaller drawing. Significantly depends on the Final level."; 
      msg.removeAttribute("class");            
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");
    }
  }    
  
  else if (my_id === "resol")  {                                                                                                                                            
    msg.textContent= (e.value === "0") ? "Suitable for lower screen resolutions and/or more options. Only basic geometric shapes that are easier to distinguish will be used." : "Suitable for higher screen resolutions and/or fewer options. All geometric shapes will be used.";
  }  
    
  else if (my_id === "tcolor")  {                                                                                                                                            
    msg.textContent= (e.value === "0") ? "The drawings will only appear in 10 different colors (recommended)." : "The drawings will be displayed in all possible colors (in some percent of cases it is possible to generate very similar colors that are difficult to distinguish).";
  }      
  
  else if (my_id === "color_emoji")  {                                                                                                                                            
    msg.textContent=(e.checked) ?  "Yes" : "No (Use default color palette: Browser dependent)";      
  }   
   
  else if (my_id === "is_back")    {
    msg.textContent= (e.checked) ?  "Yes" : "No";         
  }
  
  else if (my_id === "is_forward")    {
    msg.textContent= (e.checked) ?  "Yes" : "No";         
  }
    
  else if (my_id === "demo")  
  {
    if (e.checked) {
      msg.textContent= " (Yes -The correct answer will have a background in this color)";
      msg.setAttribute("style", "background-color:#FFFFF0");   // ivory
    }
    else  {
      msg.textContent=" (No)";
      msg.removeAttribute("style");
    }    
  }
  
  else if (my_id === "is_shadow")  
  {
    if (e.checked) {
      msg.textContent= " Yes -Screen section that shows the options offered will have this background color - Azure";
      msg.setAttribute("style", "background-color:#F0FFFF");   // azure
    }
    else  {
      msg.textContent=" No - The background color of the screen will be white (default)";
      msg.removeAttribute("style");
    }    
  }
  
  
  // storage (1x)
  else if (my_id === "store")  {                                                                                                                                            
    msg.textContent= (e.value === "1") ? "This web application will store the results inside your web browser (no expiration date). Useful for group research" : "This web application will not store results within your web browser. Data is lost when the browser tab is closed";
  }  
  
  refMsg();   
}


// update item count on options form and check lc <= hc and update  label itemCnt = wc*(hc-lc+1);
function refItem()  
{
   var _lc = document.getElementById("lc");
   var _hc = document.getElementById("hc");
   var _wc= document.getElementById("wc");
   var _item= document.getElementById("item_cnt");
   var lc_msg= document.getElementById("lc_msg");
   var hc_msg= document.getElementById("hc_msg");    
   if (_lc.validity.valid  && _hc.validity.valid && _wc.validity.valid)   
   {                      
     var my_min= parseInt(_lc.value,10);
     var my_max= parseInt(_hc.value,10);
     var my_w= parseInt(_wc.value,10);
     if  (my_min > my_max)  
     {
       lc_msg.textContent= "The starting level must not be higher than the final level";  
       hc_msg.textContent= "The starting level must not be higher than the final level";
       lc_msg.setAttribute("class", "error");
       hc_msg.setAttribute("class", "error");    
       _item.textContent= "Total number of items: Invalid value"; 
       _item.setAttribute("class", "error");
     }
     else if  ( my_w * (my_max - my_min + 1) > 5000 )
     { 
        document.getElementById("wc").value= Math.floor(5000/ (my_max - my_min + 1)); 
        _item.textContent= "Total number of items was too large (maximum is 5000). Number of tasks within each level is set automatically = " + document.getElementById("wc").value; 
        _item.setAttribute("class", "error");
     }
     else   {                                                                                               
       lc_msg.removeAttribute("class");    //lc_msg.textContent= _lc.value;
       hc_msg.removeAttribute("class");   //hc_msg.textContent= _hc.value; 
       _item.textContent=  "Total number of items: " +  ( parseInt(_wc.value,10) * (parseInt(_hc.value,10)-parseInt(_lc.value,10)+1));      
       _item.removeAttribute("class");
     }
   } 
   else  
   {
     _item.textContent= "Total number of items: Invalid value"; 
     _item.setAttribute("class", "error");
   }    
}


// refresh main validator message for user defined OPTIONS (feedback to user)
function refMsg()   
{ 
 if ( optionsValid() )   {
    document.getElementById("is_valid").textContent=  (dirty===true) ? "All your settings have been successfully updated" : "";  
    document.getElementById("is_valid").style="text-align:center;color:#000000"; 
  }
  else  {
    document.getElementById("is_valid").textContent="Some of your options are incorrectly set. They were not updated. These settings are marked in red."; 
    document.getElementById("is_valid").style= "text-align:center;color:#ff0000;font-weight:bold"; // safari 5.1.7 bug? => this don't work
  } 
}


// check for validity.valid object in all input type="number" (6x)
function optionsValid()  
{     
  var res=  document.getElementById("lc").validity.valid && 
    document.getElementById("hc").validity.valid &&
    (parseInt(document.getElementById("lc").value,10) <= parseInt(document.getElementById("hc").value,10))  &&   
    document.getElementById("wc").validity.valid  &&          
    document.getElementById("timer").validity.valid &&            
    document.getElementById("ch").validity.valid &&
    document.getElementById("size").validity.valid;
    return res;       // Firefox parser don't execute code ok without res var           
}


// start wm7 Task (start Research or Test) 
function startTask(e)   
{     
  if (emoji) stype = "2";   // always vary only shape for emoji
  
  e.disabled= true;
  stimGenerator(); 
  e.disabled= false;   
  do  
   var ok= e.disabled;
  while (ok); // timer will wait for stimulus generator for large itemCnt 
  document.getElementById("google-wrapper").style.display="none";
  document.getElementById("end").style.display= "none"; 
  document.getElementById("start").style.display= "none"; 
  document.getElementById("canvas").style.display="block";            
    
  counter= 0;
  timer_enabled= (document.getElementById("timer_enabled").checked) ? true: false;  // timer is enabled or disabled
  if  (timer_enabled)  {
    document.getElementById("progress").style.display= "block"; 
    document.getElementById("progress").setAttribute("style", "width:100%");
  }
  else  {
    document.getElementById("progress").style.display= "none";
    document.getElementById("time_left").textContent= "";
  }
  is_task= true;  // finally activate timer
  
  item=0;
  drawStim();     // draw first stimulus     
}


// set application variable parameters
function setVarPar()  {   
  
  if (document.getElementById("lc").validity.valid && document.getElementById("hc").validity.valid 
    && (parseInt(document.getElementById("lc").value,10) <= parseInt(document.getElementById("hc").value, 10) ) )   {  
      lc= parseInt(document.getElementById("lc").value, 10); 
      hc= parseInt(document.getElementById("hc").value, 10); 
  }
  
  if (document.getElementById("wc").validity.valid) wc= parseInt(document.getElementById("wc").value, 10);        
  
  is_shuffle= (document.getElementById("is_shuffle").value === "1") ? true: false;
  
  is_cor= (document.getElementById("is_cor").value === "1") ? true: false;
  
  uniq= (document.getElementById("uniq").value === "1") ? true: false;
    
  if (document.getElementById("timer").validity.valid) timer= Math.round(parseInt(document.getElementById("timer").value, 10));  
 
  // not here. see startTask() => timer_enabled= (document.getElementById("timer_enabled").checked) ? true: false;  // timer is enabled or disabled
  
  emoji = (document.getElementById("emoji").value === "1") ? true : false ;  // stimulus type ("1" => Emoji or "0" => Geometric Shapes) 
             
  stype = document.getElementById("stype").value;      // change  (color, shape, position,..)
  
  if (document.getElementById("ch").validity.valid)  ch = parseInt(document.getElementById("ch").value, 10);     // options count           
  
  if (document.getElementById("size").validity.valid) {
    var tmp= parseInt(document.getElementById("size").value, 10);
    if (arr_size[tmp-1])  size=  arr_size[tmp-1];          
  }
  
  tcolor= (document.getElementById("tcolor").value === "0") ? false: true;  // false => only use 10 basic colors; true => use full random colors palette     
  
  is_back= (document.getElementById("is_back").checked) ? true: false;   // enable Go back (previous item)      
  
  is_forward= (document.getElementById("is_forward").checked) ? true: false; // enable skip item
  
  demo= (document.getElementById("demo").checked) ? true: false; // demo mode = true => show correct solution
  
  is_shadow= (document.getElementById("is_shadow").checked) ? true: false;    // if (true) => shadow screen answers (options) sections
  
  store= ( document.getElementById("store_group").disabled === false && document.getElementById("store").value === "1") ? true : false;
  
  if (emoji) {
    s_max= arr.length-1;
  }
  else  {
    if ( !uniq &&  (stype === "0" || stype === "2")  && !document.getElementById("resol").disabled && document.getElementById("resol").value === "0")  {
      s_max= 21;
    }
    else  {
      s_max= 40;
    }  
  }
}


// set internal application research parameters
function setPar()  {  
  itemCnt= wc*(hc-lc+1);               
  stim_b = [];    // bounds for choices
  stim = [];   //  jagged array [item][] Within each [item] is separate array with grid coordinates 
  cor = [];  // correct solution for each item
  ans = [];  //  user answers for each item (dependent var)
  for (var j= 0; j<itemCnt; j++)   {
    ans[j]= 0;    // set all answers with default: no answer = 0. don't change this. see: setStim() 
  }
}


// main wm7 stimulus generator function
function stimGenerator()  
{ 
  setPar();
  var hor = (window.innerWidth > window.innerHeight) ? true : false;         
  var cnt= (hor) ? 4 : 2;   // default maximum options count in each row  
  // update maximum options count in each row => set optimal screen layout for horizontal viewport
  if (hor)  {
    if (ch === 5 || ch === 6)  {
      cnt=3;     // 2 rows x 3 options
    } 
    else  if (ch === 9)  {
      cnt=3;    // 3 rows with 3 options
    }
  }   
  
  setChoicesBounds(cnt);
  
  var raster= setRaster(0); 
  
  var i= 0;    // ordinal item count [0..itemCnt-1] 
  for (var j=lc; j<=hc; j++)  
  {  // from low level to high level      
     
    for (var k=1; k<=wc; k++)  
    {    //   from lf to hc (wc-times)  
      stim[i]= []; 
      for (var m=0; m<=ch; m++)  
      {  // for each choices within wc          
        var b= ( m===0 ) ? true: false;  // if (b) generate color and shapes
        stim[i][m]= setCoord(stim_b[m][0], stim_b[m][1], stim_b[m][2], stim_b[m][3], raster, b);
        if (m === 0) {                                     
          var tmp= stim[i][m];  // remember match stimulus (target stimulus)
        }
        else 
        {    
          for (var h in stim[i][m]) 
          {            
            stim[i][m][h][3]= tmp[h][3]; // copy color from match stimulus
            stim[i][m][h][4]= tmp[h][4]; // copy shape from match stimulus
          }
        }                            
      }                
      i++;    // next item
    }  // k= within each level
  }   // j = from low level to high level
         
  setRadius();  
  setStim();  
}


/*   set canvas (viewport) choices (options) bounds        
   stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..ch 
   input argument: w_row = maximum option within each row 
   for VERTICAL (window.innerHeight > window.innerWidth) screens: 
   call this function with low value w_row (example: 1..3)
   for HORIZONTAL screens: call this function with higher value w_row (5..10)  
   divide screen vertical into row_cnt equal vertical segments
   first row is always match stimulus    */                                                                                
function setChoicesBounds(w_row)  
{  
  document.getElementById("footer").style.display="block";  // here or in startTask()
  document.getElementById("footer").height= "50";  // const. see img: backward.png => height and forward.png.height  
  var canvas= document.getElementById("canvas");     
  canvas.left= 0; canvas.top= 0;
  canvas.width= window.innerWidth;       // stretch canvas to parent
  canvas.height= window.innerHeight - document.getElementById("footer").height;    
  var xs= canvas.width/2;     // horizontal center  
  // p = (total viewport space reserved for all options in one row/column ) / 100;     
  var p= 0.9;   // full row/column space is 1. in this case 90% of canvas.width is reserved for all option in on row   
  // compute all stimulus width (width=height)
  var row_cnt = Math.ceil(ch/w_row) + 1;  // options total row count + one row for match stimulus.               
  var wy= p * canvas.height/(row_cnt+1);  // width for match stimulus and all options (answers)
  var wx= p * canvas.width/(w_row+1);
  var w= Math.round(Math.min(wx, wy));  // this is stimulus width (width=height) for match stim and all options          
  // set screen position for MATCH stimulus => first row (top segment of screen) 
  var y= divLine(canvas.top, canvas.top + canvas.height, -1/row_cnt);        
  stim_b[0]= [Math.round(xs-w/2), Math.round(y-w/2), Math.round(xs+w/2), Math.round(y+w/2)];   
  // set OPTIONS (answers) stimulus position on screen (bellow match/target stimulus). they all have equal width and height like match stimulus     
  var i= 1, row = 1, new_row= false, nx, ny, x, y;
  for (var j=1; j<=ch; j++)  
  {                       
    if (new_row) {
      i=1;   // reset counter                    
      row++;
    }                                    
    nx = (w_row <= ch) ?  -i/(w_row-i+1) :  -i/(ch-i+1);     // nx = x-coord divide screen ratio for each option within each rows (x-coord)         
    // only for last row: you can comment next line if you don't won't horizontal center options in last row  
    //if (row + 1 === row_cnt)   nx= -i/(ch-j+1);      
    x= divLine(canvas.left, canvas.width,  nx);               
    ny= -(row+1)/(row_cnt-row);   // ny = y-coord divide screen ratio for columns. example divide line into 7 equal segments=> lambda= [-1/6; -2/5; -3/4; -4/3;-5/2;-6/1]             
    y= divLine(canvas.top, canvas.top + canvas.height, ny);                        
    stim_b[j]= [Math.round(x-w/2), Math.round(y-w/2), Math.round(x+w/2), Math.round(y+w/2)];   // 0 = left; [1] = top; [2] = right; [3]= bottom        
    new_row= (j % w_row === 0) ? true : false;  // reset counter in next iteration if neccesary
    i++;                            
  }                           
}

   
/* divide line 
  first => first point (P1) 
  second => second point (P2)
   n => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
   returns: coordinate of point (Q) between first and second point 
  if  n > 0 => point Q is witnin line; else Q is out of line
  if n = lambda = -1 => divide line into 2 equal parts
  examples:   
  divide line into 2 equal parts n = lambda = -1/1= -1 
  divide line into 3 equal parts n = lambda = [-1/2, -2/1] 
  divide line into 4 equal segments=> n=  [ -1/3, -2/2, -3/1]
  divide line into 5 equal segments=> n=  [-1/4;-2/3;-3/2;-4/1] 
  divide line into 6 equal segments: n=  [-1/5; -2/4, -3/3; -4/2; -5/1].
  divide line into 7 equal segments: n= [-1/6; -2/5; -3/4; -4/3;-5/2;-6/1]
  divide line into 8 equal segments: n=[-1/7; -2/6; -3/5; -4/4; -5/3; -6/2; -7/1]
*/   
function divLine(first,second,n)  {     
  return (first-n*second)/(1-n);   // Math.round((first-n*second)/(1-n));
}


// x1 => first point P1 x-coord
// x2 => second point P2 y-coord
// n => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
// returns: x-coord of Q point
function div_x(x1,x2,n)  {   
  return (x1-n*x2)/(1-n);
}


// y1 => first point P1 y-coord
// y2 => second point P2 y-coord
// n  => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
// returns: y-coord of Q point
function div_y(y1,y2,n)  {   
  return (y1-n*y2)/(1-n);
}


// set raster for main stimulus generator function or setRadius() function
function setRaster(sender)
{
  if (stype === "3") { 
    var raster= (hc <= 3) ? (4+sender) : (hc+sender);    // if sender is stimulusGenerator()  3=>4; if sender is setRadius() => 3=>5  (hardcoded fixed values). checked ok
  }   
  else  {
    var raster=Math.ceil(Math.sqrt(hc)) + sender;     // if sender is stimulusGenerator()  => raster= Math.ceil(Math.sqrt(hc));  if sender is setRadius() =>  raster=Math.ceil(Math.sqrt(hc))+1 
  }     
  return raster;
}


// set match and sample coordinates; generate stim-coord (x,y) and default properties (visible, color, shapes type)
// divide screen section into raster equal segments (x-horizontal and y-vertical) 
// if (b===true) generate color and shapes
// return array (item) stim coordinates. 
function setCoord(_left, _top, _right, _bottom, raster, b) 
{  
  var arr= [];    //stim[i]= []; => return stim-coord for next item     
  var sel= {};  // already selected shapes => they can be selected ONLY ONCE if uniq === true
  for (var k=1; k<=raster; k++) 
  {  // divide line (screen section) into raster equal segments  => divide screen section vertical - y      
    for (var j=1; j<=raster; j++)  
    {          
      // divide line (each row) into raster equal segments again => divide screen section horizontal-x          
      // divide line horizontal -x; last arg = lambda = -m/n. example divide line into 6 equal segments: lambda= [-1/5; -2/4, -3/3; -4/2; -5/1]. 
      // example divide line into 4 equal segments=> lambda= [ -1/3, -2/2, -3/1]
      var x= div_x(_left, _right, -j/(raster-j+1));                 
      // y= const within each row;  last arg = lambda = -m/n. example divide line into 4 equal segments => lambda= [-1/3, -2/2, -3/1]     
      // divide line vertical -y; last arg = lambda = -m/n. example divide line into 8 equal segments: lambda=[-1/7; -2/6; -3/5; -4/4; -5/3; -6/2; -7/1]
      // example divide line into 7 equal segments=> lambda= [-1/6; -2/5; -3/4; -4/3;-5/2;-6/1]. example divide line into 5 equal segments=> lambda= [-1/4;-2/3;-3/2;-4/1]             
      var y= div_y(_top, _bottom, -k/(raster-k+1));               
      // see stimGenerator() => all options stimulus will have overwritten values for color and shape
      if (b)
      {       // if (b) generate color and shapes
        if (stype === "0") 
        { // vary color and shape
          var col= (tcolor) ? getRndColor() : get10Color(); 
          if (uniq)
          {
            do
              var shape= getRndInt(0, s_max);
            while (typeof sel[shape] != "undefined");
            sel[shape]= shape;
          }
          else {        
            var shape= getRndInt(0, s_max); 
          }
        }
        else if (stype === "1") 
        {  // vary only color
          var col= (tcolor) ? getRndColor() : get10Color();
          var shape= 0;    // circle
        }
        else if (stype === "2") 
        {    // vary only shape
          if (emoji && document.getElementById("color_emoji").checked )  {
            var col= (tcolor) ? getRndColor() : get10Color();
          }
          else {
            var col= "#000000";        // black
          }
          if (uniq)
          {
            do
              var shape= getRndInt(0, s_max);
            while (typeof sel[shape] != "undefined");
            sel[shape]= shape;
          }
          else {        
            var shape= getRndInt(0, s_max); 
          }  
        }       
        else if (stype === "3") 
        {    // vary only position
          var col= "#000000";   // black
          var shape= 0;  // circle
        }                              
        arr.push([0, x, y, col, shape]);     // index: [0=visible; 1 = x; 2=y; 3 = color; 4= shape]; all are invisible by default => see setStim()          
      }
      else {
        arr.push([0, x, y, null, null]);   // don't generate color and shapes index: [0=visible; 1 = x; 2=y; 3 = color; 4= shape]
      }
    } // j = horizontal (x) divide
  } // k = vertical (y) divide
  return arr;  
}


// Sets one of 10 predefined colors (can these colors be distinguished by most of the population?)
function get10Color() 
{
  var rnd =  Math.floor(Math.random()*10);   // 0..9
  switch (rnd)  
  {    
    case 0:  return "black";
    case 1:  return "silver";  // grey
    case 2:  return "red";
    case 3:  return "green";
    case 4:  return "blue";
    case 5:  return "orange";
    case 6:  return "lime";
    case 7:  return "purple";
    case 8:  return "aqua"; // olive
    case 9:  return "pink";
  }
}


// get full random colors in hex format
function getRndColor() {
  var letters = '0123456789abcdef';
  var color = '#';
  for (var i=0; i<6; i++) {
    color += letters[Math.floor(Math.random() * 16)];     // returns a random integer from 0 to 15 
  }
  return color;
}  


// set window.r radius
// why must be in separate function? This code don't work OK in stimGenerator() 
function setRadius()  
{ 
  var raster=setRaster(1);
  // 0 = left; [1] = top; [2] = right; [3]= bottom
  if (hc=== 1 && raster === 2 && stype != "3" )  {
    var w= Math.round(0.95*(stim_b[1][2] - stim_b[1][0]));  // 95% square width for special case if only one shape
    var h= Math.round(0.95*(stim_b[1][3] - stim_b[1][1]));   // 95% square height for special case if only one shape
  }
  else  {
    var w= (stim_b[1][2] - stim_b[1][0])/raster; // choice_width/raster = choice_height/raster = right - left = const => this choice always exists
    var h= (stim_b[1][3] - stim_b[1][1])/raster; // choice_height/raster = choice_width/raster = bottom - top = const => this choice always exists          
  }          
  r= Math.floor( size * 0.5 * Math.min(w,h) );  // set shape size
  //window.r=Math.round(0.90*window.r);    // leave 10% blank space within rect   
  if (r < 5)  alert("Your screen resolution is probably not enough to distinguish the drawings that will be displayed.\nPossible solutions:\n  -reduce Final level to a smaller value Currently= " + hc + "\n  -reduce the Number of options. Currently=" + ch + " \n  -increase the Shape size to the maximum \n  -do not use Change: Position");
}


/*  
set wm7 stimulus for each item 
set difference between target stimulus and other stimulus/option
none or only one option is equal to match (target) stimulus, 
other stimuli are different ONLY in ONE shape (color and/or shape)
*/
function setStim()  {     
  var i= 0;        // i= item => ordinal item count [0..itemCnt-1]
  var max= stim[i][0].length;     // target (match) stimulus and all options stimulus have equal length     
  for (var vis=lc; vis<=hc; vis++)  
  {   // vis = number of visible shapes within this item
    for (var j=0; j<wc; j++)  
    {    //   from lf to hc (wc-times)                        
      // choose random visible shapes within this item
      for (var k=0; k<vis; k++)  
      {
        do  
          var rnd = Math.floor(Math.random()*max); // rnd= random choose one of shapes in all stimulus in this (i) item  
        while (stim[i][0][rnd][0] === 1);   // check if this shape is already choosen (match [0] stimulus)        
        for (var c in stim[i])      {     // c= choices within each item (i)            
          stim[i][c][rnd][0]=1;       // this shape will be visible (match stimulus + all options stimulus)          
        }
      }
      i++;     
    }
  }  
    
  // change shape (color, position) in ONLY ONE shape within each choices (except correct solution = target=match stimulus)
  for (var i in stim) 
  {     // i= item                                                             
    var correct= (is_cor && ch > 1) ? getRndInt(1,ch) : getRndInt(0,ch);    // choose correct solution, pick one of options stimulus within item (or none)
    cor[i]=correct;   // save correct solutions for each item
    do  
      var s =  Math.floor(Math.random()*max);  // random choose only one of shapes within match stimulus => s = selected shape   
    while (stim[i][0][s][0] === 0);   // selected shape must be VISIBLE (stim[i][0] = match stimulus)        
    var sel= {};  // already selected random colors/shapes/positions => they can be selected ONLY ONCE             
    // set difference between target stimulus and other stimulus/option
    for (var c in stim[i]) 
    {    // c= choices within each item  (c = 0 => match (target) stimulus; c > 0 => options stimulus)            
      if (c == 0 || c == correct) continue; // escape match stim and target stimulus (don't use ====)                 
      if (stype === "0")  
      {  //  "0" => change shape OR color only in only ONE shape except target
        if (Math.random() < 0.5)
        { // change color (in only ONE shape except target)
          var ind=3;  // index for color is 3 => stim[i][c][s][3]
        }
        else 
        {  // change shape type (in only ONE shape except target)
          var ind = 4;  // index for shape is 4 => stim[i][c][s][4]
        }  
        do   
          if (ind === 3) {
            var rnd =  (tcolor) ? getRndColor() :  get10Color();    // choose different color for all sample stimulus except target and match stim
          }  
          else  {
            var rnd =  getRndInt(0, s_max);   // choose different shape
          }  
        while (stim[i][0][s][ind] == rnd || typeof sel[rnd] != "undefined");  //while (stim[i][0][s][3] == col || sel[col]) => browser warning 
        stim[i][c][s][ind]= rnd; // change shape or color in all options except correct solution
        sel[rnd]= rnd;              
      }
      else if (stype === "1")  
      {  //  "1" => change only color in only ONE shape except target
        do  
          var col= (tcolor) ? getRndColor() : get10Color();  // choose different color for all sample stimulus except target and match stim  
        while (stim[i][0][s][3] == col || typeof sel[col] != "undefined");  //while (stim[i][0][s][3] == col || sel[col]) => browser warning 
        stim[i][c][s][3]= col; // change color in all shapes
        sel[col]= col;
      }      
      else if (stype === "2")  
      {   // "2" => difference is only shape
        do  
          var shape= getRndInt(0, s_max);  // choose different SHAPE for all sample stimulus except target and match stim  
        while (stim[i][0][s][4] == shape || typeof sel[shape] != "undefined");  
        stim[i][c][s][4]= shape; // change shape
        sel[shape]= shape;
      }      
      else if (stype === "3")  
      {   // "3" => difference is only position (change 2 positions)
        do  
          var pos =  Math.floor(Math.random()*max);  // random new position    
        while (stim[i][0][pos][0] === 1 || typeof sel[pos] != "undefined");   // new position must be INVISIBLE  and must be choosen only once within item
        // swap visible and invisible
        stim[i][c][s][0]= 0;     // original (match) stim is INVISIBLE
        stim[i][c][pos][3]= "#000000"; 
        stim[i][c][pos][0]= 1; // new position is VISIBLE 
        sel[pos]= pos;
      }       
                                            
    }   // for (var c in stim[i]) =>  c= choices within each item  (c = 0 => match (target) stimulus; c > 0 => options stimulus)     
  } 
  
  if (is_shuffle)  
  {
    stim = shuffle(stim);      
    // try to avoid:  prior item and current item are equal (maximum 5 x shuffle items). only if is_shaffle= true 
    for (var j= 1; j<=5; j++)  
    {    
      for (var i=1; i< stim.length; i++) 
      {   
        if ( areEqual(stim[i][0], stim[i-1][0]) )   {  
          stim= shuffle(stim);    // try shuffle again                
        }  
      }
    }
  } 
      
  delInv();     // always do it on END => because of  var max= stim[i][0].length and areEqual() don't work ok (undefined objects);     
  
}


// check if prior item and current item are equal. only for target (match) stimulus
function areEqual(current, prior)  
{
  for (var shape in current)  {          
    if ( current[shape][0] != prior[shape][0]  ||  current[shape][3] != prior[shape][3] || current[shape][4] != prior[shape][4]) return false; // compare colors and shapes for visible items      
  }
  return true;
}


// delete (unset) all invisible shapes because of better future performance in drawStim() method
function delInv()  {   
  for (var i in stim)  
  {  // i= item
    for (var j in stim[i]) 
    { // j= choices within item => j = 0 => match stimulus; j> 0 => sample stimulus                     
      for (var k in stim[i][j])  
      {   // k= shapes within choices
        if (stim[i][j][k][0] === 0)   delete(stim[i][j][k]);  // this works OK. tested with simple counter in drawStim(). don't use this: stim[i].splice(j, 1);
      }
    }
  }
}


// unbiased shuffle algorithm: Fisher-Yates (aka Knuth) Shuffle.
function shuffle(arr) {
  var cur_ind = arr.length, rnd_ind, tmp;
  // while there remain elements to shuffle...
  while (0 !== cur_ind) {    
    rnd_ind = Math.floor(Math.random() * cur_ind);     // pick a remaining element...
    cur_ind = cur_ind - 1;   
    tmp = arr[cur_ind];          // swap it with the current element.
    arr[cur_ind] = arr[rnd_ind];
    arr[rnd_ind] = tmp;  
    // don't forget to shuffle correct answers
    tmp = cor[cur_ind];          // swap it with the current element.
    cor[cur_ind] = cor[rnd_ind];
    cor[rnd_ind] = tmp;  
  }
  return arr;
}


// ger random integer from min to max range
function getRndInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}


// application timer handler function
function wm7Timer()  {  
  if (!timer_enabled || !is_task) return;  // nop, idle        
  counter++;
  var rest=timer-counter;   // (timer-counter) = remaining time 
  var percent = 100*rest/timer;  // Math.round(); =>   
  document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important    
  document.getElementById("time_left").textContent= string_time(rest);  //+ " item= " + item + " itemCnt= " + itemCnt;  
  if (counter >= timer)  theEnd();
} 


// total = integer
function string_time(total) {
  var hh = Math.floor(total/(60*60));
         
  var divisor_for_minutes = total % (60 * 60);
  var mm = Math.floor(divisor_for_minutes / 60);
       
  var divisor_for_seconds = divisor_for_minutes % 60;
  var ss = Math.ceil(divisor_for_seconds);
    
  // These lines ensure you always have two-digits. This formats your string to HH:MM:SS
  if (hh < 10)  {hh = "0"+hh;}     
  if (mm < 10) {mm = "0"+mm;}
  if (ss < 10) {ss = "0"+ss;} 
  return hh + ":" + mm + ":" + ss;
} 


// goto previous item (stimulus)
function priorAnswer()  {                         
  if (item > 0) {
    item--;  
    drawStim();     // draw again previous stimulus
  }         
}


// goto next item (stimulus)
function nextItem()  {               
  if (item < itemCnt-1)  {         
    item++; 
    drawStim();     // draw next stimulus        
  }
  else  {               
    theEnd();  // end of task  
  }
}


// draw (repaint) stimulus    
function drawStim() 
{    
  var canvas= document.getElementById('canvas');
  var ctx = document.getElementById('canvas').getContext('2d'); 
  ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas             
  for (var j in stim[item]) 
  {    // j= choices within item => j = 0 => match stimulus; j> 0 => sample stimulus              
    // draw border around each choices bounds
    ctx.beginPath(); 
    ctx.strokeStyle= "#000000";
    /* [0] = left; [1] = top; [2] = right; [3]= bottom
        choice_width=  stim_b[j][2] - stim_b[j][0];  // right - left
        choice_height= stim_b[j][3] - stim_b[j][1]; // bottom - top    */  
    ctx.rect(stim_b[j][0],  stim_b[j][1], stim_b[j][2] - stim_b[j][0] ,  stim_b[j][3] - stim_b[j][1]);   // draw border around each choices bounds 
    if ((j > 0) && (ans[item] == j || demo && cor[item] == j) )  
    { // set background color for selected answer or set background color in demo mode for correct answer. you must call before drawShape() handler               
      // Gray90 == selected or Ivory == correct 
      ctx.fillStyle = (ans[item] == j)  ?   "#E5E5E5" : "#FFFFF0";  // the selected answer takes precedence over the correct answer (background color)                   
    }
    else  {
      ctx.fillStyle = "#FFFFFF";
    }  
    ctx.fill();   
    ctx.stroke();    // draw border around each choices bounds
    for (var k in stim[item][j])   
    {   // k= shapes within choices [k]                                        
        /* this section draw square border for each shape/emoji 
        ctx.beginPath();  
        ctx.rect(stim[item][j][k][1]-window.r, stim[item][j][k][2]-window.r, 2*window.r,  2*window.r);   //  	context.rect(x,y,width,height);
        ctx.strokeStyle=  "#000000"; 
        ctx.stroke();
        */       
      if (emoji)  {
        drawEmoji(ctx, stim[item][j][k][1], stim[item][j][k][2], stim[item][j][k][3], stim[item][j][k][4]);   
      }
      else  {
        drawShape(ctx, stim[item][j][k][1], stim[item][j][k][2], stim[item][j][k][3], stim[item][j][k][4]);
      }          
    }
    //  after draw match stimulus => this section draw different background color (not white) for all options (options backgroundColor != match backgroundColor)
    if (is_shadow && j == 0) 
    {  
      ctx.beginPath(); // must be here
      ctx.rect(0,  stim_b[1][1], canvas.width, canvas.height - stim_b[1][1]); 
      ctx.fillStyle = "#F0FFFF";    // azure 	#F0FFFF 	rgb(240,255,255)
      ctx.fill();  
      //ctx.stroke(); //ctx.fillStyle = "#FFFFFF"; 
    }      
                           
  }           
  // set footer navigation buttons
  if (ch === 1 || is_cor === false  || is_forward)       //item < itemCnt
  {  
    var btn=document.getElementById("next");     
    btn.style.backgroundImage = (item === itemCnt-1)  ?  "url('img/end.png')" : "url('img/forward.png')"; 
    btn.style.display= "inline";  
  }
  else {
    document.getElementById("next").style.display= "none";
  }
  if (item > 0 && is_back)  {  
    document.getElementById("prior").style.display= "inline"; 
  }
  else  {
    document.getElementById("prior").style.display= "none";   
  }  
}


// draw all emoji
function drawEmoji(ctx, x, y, col, shape)
{               
  //x-=r;    
  y+=r;                                                                   
  // https://developer.mozilla.org/en-US/docs/Web/CSS/font-family   https://www.w3schools.com/cssref/css_websafe_fonts.asp
  ctx.font = Math.round(1.5*r).toString() + "px monospace, Courier";    
  ctx.textBaseline="bottom";       ctx.textAlign = "center";  
  // Firefox, Chrome, Edge, Opera: ignore ctx.fillStyle and  ctx.strokeStyle= col  
  ctx.fillStyle = col;   // fill color => this line must be (only necessary for: IE11, Safari) 
  ctx.strokeStyle= col;  // line color (outer border line color). (only necessary for: IE11, Safari)            
  // why using: "tmp" element? because  Backward compatibility.  why not:  String.fromCodePoint()  ?  see: https://caniuse.com/#search=fromCodePoint
  //ctx.fillText(String.fromCodePoint(arr[shape]), x, y);     // direct decimal to emoji. => don't work in IE11, Opera Mini,..
  document.getElementById("tmp").innerHTML="&#" + arr[shape]; 
  ctx.fillText(document.getElementById("tmp").innerHTML, x, y);     // end of draw point number within each Circle       
  //ctx.strokeStyle= "#000000";  // restore to black  
}


/* shape function dispatcher (handler)
   ctx = canvas context
   x = x coord square center,
   y = y coord square center
   col = color (fillSyle and/or strokeStyle)
   shape = shape type => this argument is main for call different shapes.js function
   shapes.js file must be included in DOM  (wm7.html)
*/ 
function drawShape(ctx, x, y, col, shape)
{
   switch (shape)  
   {
     case 0:   // full circle
     case 1:   // 1/2 circle RIGHT oriented
     case 2:   // 1/2 circle DOWN oriented   
     case 3:   // 1/2 circle LEFT oriented
     case 4:   // 1/2 circle UP oriented 
     case 5:   // 3/4 circle with UP-RIGHT hole
     case 6:   // 3/4 circle with DOWN-RIGHT hole
     case 7:   // 3/4 circle with DOWN-LEFT hole 
     case 8:   // 3/4 circle with UP-LEFT hole                          
       if (shape === 0)  {                        
         circle(ctx, x, y, r, 0, 2*Math.PI, false, col);  // full circle 
       }        
       else if (shape === 1)  {
         circle(ctx, x, y, r, 1.5*Math.PI, 0.5*Math.PI, false, col); // 1/2 circle RIGHT oriented      
       }
       else if (shape === 2)  {
         circle(ctx, x, y, r, 0, Math.PI, false, col); // 1/2 circle DOWN oriented     
       } 
       else if (shape === 3)  {
         circle(ctx, x, y, r, 0.5*Math.PI, 1.5*Math.PI, false, col); // 1/2 circle LEFT oriented     
       } 
       else if (shape === 4)  {
         circle(ctx, x, y, r, Math.PI, 0, false, col);   // 1/2 circle UP oriented     
       }        
       else if (shape === 5)  {
         circle(ctx, x, y, r, 0, 1.5*Math.PI, false, col);   // 3/4 circle with UP-RIGHT hole     
       } 
       else if (shape === 6)  { 
         circle(ctx, x, y, r, 0, 0.5*Math.PI, true, col);   // 3/4 circle with DOWN-RIGHT hole     
       } 
       else if (shape === 7)  { 
         circle(ctx, x, y, r, 0.5*Math.PI, Math.PI, true, col);   // 3/4 circle with DOWN-LEFT hole     
       } 
       else if (shape === 8)  { 
         circle(ctx, x, y, r, 1.5*Math.PI, Math.PI, false, col);   // 3/4 circle with UP-LEFT hole     
       }        
       break;
        
     case 9:   // polygon 3 equal sides
     case 10:  // polygon 4 equal sides   
       (shape === 9) ?  polygon(ctx, x, y, r, 3, col):  polygon(ctx, x, y, r, 4, col);       
       break;    
          
     case 11:
       square(ctx, x, y, r, col);    
       break;
     
     case 12:    // longer side (base) down
     case 13:    // longer side (base) up
       (shape === 12) ? trapezoid(ctx, x, y, r, col, true) : trapezoid(ctx, x, y, r, col, false) ;  // base down or up   
       break;
      
     case 14: // rectangle - horizontal line is longer then vertical
     case 15: // rectangle - vertical line is longer then horizontal 
       (shape === 14) ? rectangle(ctx, x, y, r, col, true): rectangle(ctx, x, y, r, col, false);              
       break;
           
     case 16:
     case 17:
       if (shape === 16) {   // vertical ellipse
        var w= r, h= 2*r; // change this 2 param for PI/2 rotation
       }
       else {   // horizontal ellipse
        var w= 2*r, h= r; // change this 2 param for PI/2 rotation
       }
       ellipse(ctx, x - w / 2.0, y - h / 2.0, w, h, col);       
       break; 
        
     case 18: // cross => classic vertical cross
     case 19: // cross => diagonal cross (x) 
       (shape === 18) ? cross(ctx, x, y, r, col, true): cross(ctx, x, y, r, col, false);       
       break;   
     
     case 20:  //(base == true) => draw down-right rotated paralelogram; 
     case 21: // (base== false) => draw left-down rotated paralelogram
       (shape === 20) ? paralelogram(ctx, x, y, r, col, true): paralelogram(ctx, x, y, r, col, false);    
       break;
          
     // end of simple shapes mode (s_max=21) => 0..21
     
     case 22:   // star 4-points
     case 23:   // star 5-points
     case 24:   // star 6-points     
       star(ctx, x, y, shape-18, r/2, r, col);       
       break;
                    
     case 25:  //  vertical UP arrow (0)
     case 26:  //  vertical DOWN arrow (1)
     case 27:  //  horizontal LEFT arrow (2)
     case 28:  //  horizontal RIGHT arrow (3)
       arrow(ctx, x, y, r, col, shape-25);       
       break;
    
     case 29:  
     case 30:
       var a= (shape === 29) ? [r, r, 0, 0] : [0, 0, r, r];    // up rect round radius (31) or down round rect radius (32)
       roundRect(ctx, x-r, y-r, 2*r, 2*r, a, col);    
      break;
                 
      case 31:       // 1/4 circle segment UP-RIGHT oriented 
      case 32:       // 1/4 circle segment DOWN-RIGHT oriented
      case 33:       // 1/4 circle segment DOWN-LEFT oriented 
      case 34:       // 1/4 circle segment UP-LEFT oriented      
        quarter(ctx, x, y, r, shape-31, col);
        break;  
       
      case 35:
      case 36:
        (shape === 35) ? smiley(ctx, x, y, r, true, col): smiley(ctx, x, y, r, false, col); 
        break;
        
      case 37: 
      case 38:   
        //ctx.save();
        (shape === 37) ?  spiral(ctx, x, y, r, 0, 5, col) :  spiral(ctx, x, y, r, 3, 5, col);    // shape===33 => 5 spiral loops are visible; else draw spiral with 2 loops (first 3 are not visible)     
        //ctx.restore();
        break;
        
      case 39:  // polygon 5 equal sides
      case 40:  // polygon 6 equal sides      
      (shape === 39) ?  polygon(ctx, x, y, r, 5, col):  polygon(ctx, x, y, r, 6, col);       
      //break; 
                    
   }   // switch (shape) of
   
}  


// user selected answer (drawings) with mouse
//<canvas id="canvas" onclick="doAnswer(event)"></canvas>   
function doAnswer(e)  
{        
  var x= e.clientX, y= e.clientY; 
  for (var j= 1; j<=ch; j++)      // must be: j=1
  { // stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..ch
    if ( x > stim_b[j][0] && x < stim_b[j][2] &&  y > stim_b[j][1] && y < stim_b[j][3])  
    {    
      ans[item]=  (ans[item] === j) ? 0 : j;      // toggle (reset) answer if user choose already selected answer         
      drawStim(); // repaint => update backgroundColor for (un)selected answers
      if (ans[item] > 0) nextItem();
    }
  } 
}


// end of task (research)
function theEnd()  {     
  timer_enabled= false; 
  is_task= false;
  document.getElementById("canvas").style.display="none"; // this disable doAnswer() event
  document.getElementById("footer").style.display="none";
  document.getElementById("end").style.display="block";  
  var res=0, err=0, mis=0, s;  
  var total=cor.length; 
  for (var j=0; j!=total; j++)   {
    if (cor[j] === ans[j]) { 
      res++;
    }
    else if (ans[j] === 0)  {
      mis++;
    }
    else  {
      err++;
    }
  }                                                         
  s="Correct= " + res + " (" + (100*res/total).toFixed(2) + "%). Errors= " + err;
  s+= " (" + (100*err/total).toFixed(2) + "%)  Missing= " + mis + " (" + (100*mis/total).toFixed(2) + "%). Total items="  + total; 
  document.getElementById("score").textContent=s;
  document.getElementById("google-wrapper").style.display="block";
  document.getElementById("no_google").textContent="";  
  
  try  {
    drawReport(res,err,mis);  
  }
  catch (e)  {
    document.getElementById("no_google").textContent= "You must have an available internet connection to display graphs and tables. Make sure you are online."; 
  }
  
  try 
  {
    if (store) {
      drawStorage(res,err,mis);  
    }
    else  {
      document.getElementById("table3").innerHTML= "";
    }
  }
  catch (e)  { 
    document.getElementById("table3").innerHTML= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline)."; 
  }
           
}


/* async draw and display tables and charts with user results (call google API)..
 (chart = PIE + table) => Displays the sum of: correct answers, errors, and missing values 
  only if hc > lc => (chart2 = ColumnChart + table2) => show: x= shape count, y= score(correct answers), errors, maximum score (wc) group by visible shape count (lc..hc) 
  res = total correct answers in task (sum)
  err = total errors in task (sum)
  mis = total missing values in task (sum)  */
function drawReport(res, err, mis) 
{           
  // 1. (chart) draw PIE chart and table for correct, errors, missing values
   
  //    xxx  table = Displays the sum of: correct answers, errors, and missing values  xxx 
  var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Answer type');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Sum');      // sum(correct answers, errors, missing values) = number = frequencies             
  data.addRow ( ["Correct", res] );
  data.addRow ( ["Errors", err] ); 
  data.addRow ( ["Missing", mis] );                                      
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };           
  var elem= document.getElementById("table");
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options); 
  
  //    xxxxxx      PIE chart  => data are same   xxxxxxx  
  options= {
   title: 'Correct answers, errors and missing values',
   is3D: true,
   width: '100%'   
  }; 
  elem = document.getElementById("chart");   
  elem.style.display = "block"; 
  new google.visualization.PieChart(elem).draw(data, options);     // Create and draw the visualization.     
  
  if (hc <= lc) {
    document.getElementById("chart2").style.display = "none"; 
    document.getElementById("table2").style.display = "none"; 
    return;      // don't draw group by level if only one level 
  }  
  // 2. (chart2 + table2) => show: shape count, score(correct answers), errors, maximum score (wc) group by visible shape count (lc..hc)
  
  // compute frequencies => number of correct answer for each level (lc..hc)
  var freq_c= [], freq_e=[];   // frequencies for correct answers for each level, and frequencies for errors
  for (var j = lc; j <= hc; j++)  {  
    freq_c[j]= 0;
    freq_e[j]= 0;      
  }                                 
  for (var i in stim) 
  {
    var j= 0;
    // delInv() must be used for this works correct!!
    for (var k in stim[i][0])   {     
       j++;
    }                                               
    if (ans[i] === cor[i]) {
     freq_c[j]++;
    }
    else if (ans[i] != 0)  {    // ans[i] > 0
     freq_e[j]++;
    }
  }         
  var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Shape count');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Score'); 
  data.addColumn('number', 'Errors'); 
  data.addColumn('number', 'Maximum score');             
  for(var j in freq_c)   // j= lc..hc (ok checked)
  { // shape count, score within level, errors within level, maximum score in level (wc)    
    if (freq_c[j] > 0 && freq_e[j] > 0)  {
      data.addRow([ j.toString() + ". shapes", freq_c[j], freq_e[j], wc ]);     
    } 
    else if (freq_c[j] > 0 && freq_e[j] === 0)  {  // no errrors within this level
      data.addRow([ j.toString() + ". shapes", freq_c[j], {v: 0.1, f: '0'}, wc ]);     
    } 
    else if (freq_c[j] === 0 && freq_e[j] > 0)  {  // no errrors within this level
      data.addRow([ j.toString() + ". shapes", {v: 0.1, f: '0'}, freq_e[j], wc ]);     
    }
    else if (freq_c[j] === 0 && freq_e[j] === 0)  {   // no correct answers and no errors within this level (all values are missing)
      data.addRow([ j.toString() + ". shapes", {v: 0.1, f: '0'}, {v: 0.1, f: '0'}, wc ]);
    }    
   }                 
  options= {
    title: 'Results are grouped by the number of displayed shapes. Total score = ' + res,
    width: '100%',  
    hAxis: {
      title: 'Number of displayed shapes',
    }, 
    vAxis: {
      title: 'Results'
    }   
  };    
  elem= document.getElementById("chart2");
  elem.style.display = "block";   
  new google.visualization.ColumnChart(elem).draw(data, options);     // Create and draw the visualization.                       
        
   //    xxxxxxxxxxxxxx          Frequencies table group by level (number of visible shapes)       xxxxxxxxxxxxxxxxx                             
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };    // data are same         
  elem= document.getElementById("table2");
  elem.title="Total score=" + res;
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options);   
}


// draw wm7 window.localStorage
function drawStorage(res,err,mis)   
{  
  var oldItems = JSON.parse(localStorage.getItem("wm7-v1.0")) || []; 
  var id= oldItems.length+1;  
 // var timer= (document.getElementById("timer_enabled").checked) ? document.getElementById("timer").value : "";   
 // set new "record"
  var newItem = {
      'id': id,
      'date': new Date(),      
      'Correct': res, 
      'Errors': err,       
      'Missing': mis,
      'items': itemCnt,      
      'Show-correct' : (demo) ? "Yes": "No",
      'Start-level' : document.getElementById("lc").value,
      'Final-level' : document.getElementById("hc").value,
      'Within-level' : document.getElementById("wc").value, 
      'Shuffle' : document.getElementById("is_shuffle").value,
      'Correct-exist' : document.getElementById("is_cor").value,        
      'Unique':  document.getElementById("uniq").value,
      'Timer-time' : (document.getElementById("timer_enabled").checked) ? document.getElementById("timer").value : "",      
      'Stimulus-type': document.getElementById("emoji").value,
      'Change' : document.getElementById("stype").options[document.getElementById("stype").selectedIndex].textContent,
      'Option-count' : document.getElementById("ch").value,
      'Is-Back' : (is_back) ? 1: 0, 
      'Is-Forward' : (is_forward) ? 1:0     
  };

  oldItems.push(newItem);

  localStorage.setItem("wm7-v1.0", JSON.stringify(oldItems));

  createTableJSON(document.getElementById("table3"), oldItems); 
  
  document.getElementById("score").textContent+= ". (ID=" + id + ")";
 
}


// convert JSON data dynamically to HTML Table using JavaScript - Dynamically Create table with rows in JavaScript
// downloaded and adapted from source: https://www.encodedna.com/javascript/populate-json-data-to-html-table-using-javascript.htm
function createTableJSON(elem, my_json) 
{  
  // EXTRACT VALUE FOR HTML HEADER. 
  var col = [];
  for (var i = 0; i < my_json.length; i++) {
    for (var key in my_json[i]) {
        if (col.indexOf(key) === -1) {
            col.push(key);
        }
    }
  } 
  var table = document.createElement("table");
  table.setAttribute("class", "my_table");    // table.className = 'my_table';
  // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.
  var tr = table.insertRow(-1);                   // TABLE ROW.
  for (var i = 0; i < col.length; i++) {
      var th = document.createElement("th");      // TABLE HEADER.
      th.innerHTML = col[i];
      tr.appendChild(th);
  }
  // ADD JSON DATA TO THE TABLE AS ROWS.
  for (var i = 0; i < my_json.length; i++) 
  {
    tr = table.insertRow(-1);
    for (var j = 0; j < col.length; j++) {
      var tabCell = tr.insertCell(-1);
      tabCell.innerHTML = my_json[i][col[j]];
    }
  }
  // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
  elem.innerHTML= "";
  elem.appendChild(table);
}


// clear wm7 web browser storage data
function clrStorage()  
{  
  var cnt= localStorage.getItem("wm7-v1.0")  ?  JSON.parse(localStorage.getItem("wm7-v1.0")).length : 0;                                                        
  if (cnt === 0)  {
    alert("You have no wm7 data to delete");
    return;
  }  
  if ( !window.confirm("You have a total of " + cnt  + " wm7 results stored in your web browser. Continue?") ) { 
   return;
 }                                             
 if (window.confirm("Delete total saved wm7 results:  "  + cnt + ". This action cannot be undone. Final confirmation?") ) 
 { 
   window.localStorage.removeItem("wm7-v1.0"); 
   document.getElementById("store_cnt").textContent= "All data has been deleted. No data";
 }  
}
